package com.zhongzheng.modules.inform.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.inform.bo.InformCourseAddBo;
import com.zhongzheng.modules.inform.bo.InformCourseQueryBo;
import com.zhongzheng.modules.inform.bo.InformCourseEditBo;
import com.zhongzheng.modules.inform.domain.InformCourse;
import com.zhongzheng.modules.inform.mapper.InformCourseMapper;
import com.zhongzheng.modules.inform.vo.InformCourseVo;
import com.zhongzheng.modules.inform.service.IInformCourseService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-23
 */
@Service
public class InformCourseServiceImpl extends ServiceImpl<InformCourseMapper, InformCourse> implements IInformCourseService {

    @Override
    public InformCourseVo queryById(Long id){
        InformCourse db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, InformCourseVo.class);
    }

    @Override
    public List<InformCourseVo> queryList(InformCourseQueryBo bo) {
        LambdaQueryWrapper<InformCourse> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getInformId() != null, InformCourse::getInformId, bo.getInformId());
        lqw.eq(bo.getCourseId() != null, InformCourse::getCourseId, bo.getCourseId());
        lqw.eq(bo.getSectionId() != null, InformCourse::getSectionId, bo.getSectionId());
        lqw.eq(bo.getModuleId() != null, InformCourse::getModuleId, bo.getModuleId());
        lqw.eq(bo.getChapterId() != null, InformCourse::getChapterId, bo.getChapterId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<InformCourseVo> entity2Vo(Collection<InformCourse> collection) {
        List<InformCourseVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, InformCourseVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<InformCourse> page = (Page<InformCourse>)collection;
            Page<InformCourseVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(InformCourseAddBo bo) {
        InformCourse add = BeanUtil.toBean(bo, InformCourse.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(InformCourseEditBo bo) {
        InformCourse update = BeanUtil.toBean(bo, InformCourse.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(InformCourse entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }

    @Override
    public List<InformCourseVo> queryCourse(Long informId) {
        return baseMapper.queryCourse(informId);
    }
}
